"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require("react");

var _react2 = _interopRequireDefault(_react);

var _utils = require("../../utils");

var _SelectWidget = require("../widgets/SelectWidget");

var _SelectWidget2 = _interopRequireDefault(_SelectWidget);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

function rangeOptions(start, stop) {
  var options = [];
  for (var i = start; i <= stop; i++) {
    options.push({ value: i, label: (0, _utils.pad)(i, 2) });
  }
  return options;
}

function DateElement(_ref) {
  var type = _ref.type;
  var range = _ref.range;
  var value = _ref.value;
  var select = _ref.select;
  var rootId = _ref.rootId;

  var id = rootId + "_" + type;
  return _react2.default.createElement(
    "li",
    null,
    _react2.default.createElement(_SelectWidget2.default, {
      schema: { type: "integer" },
      id: id,
      className: "form-control",
      options: rangeOptions(range[0], range[1]),
      value: value,
      onChange: select }),
    _react2.default.createElement(
      "p",
      { className: "text-center help-block" },
      _react2.default.createElement(
        "label",
        { htmlFor: id },
        _react2.default.createElement(
          "small",
          null,
          type
        )
      )
    )
  );
}

var DateTimeWidget = function (_Component) {
  _inherits(DateTimeWidget, _Component);

  function DateTimeWidget(props) {
    _classCallCheck(this, DateTimeWidget);

    var _this = _possibleConstructorReturn(this, Object.getPrototypeOf(DateTimeWidget).call(this, props));

    _this.onChange = function (property, value) {
      _this.setState(_defineProperty({}, property, value), function () {
        _this.props.onChange((0, _utils.toDateString)(_this.state));
      });
    };

    _this.onYearChange = function (value) {
      return _this.onChange("year", value);
    };

    _this.onMonthChange = function (value) {
      return _this.onChange("month", value);
    };

    _this.onDayChange = function (value) {
      return _this.onChange("day", value);
    };

    _this.onHourChange = function (value) {
      return _this.onChange("hour", value);
    };

    _this.onMinuteChange = function (value) {
      return _this.onChange("minute", value);
    };

    _this.onSecondChange = function (value) {
      return _this.onChange("second", value);
    };

    _this.state = (0, _utils.parseDateString)(props.value || props.defaultValue);
    return _this;
  }

  _createClass(DateTimeWidget, [{
    key: "componentWillReceiveProps",
    value: function componentWillReceiveProps(nextProps) {
      this.setState((0, _utils.parseDateString)(nextProps.value || nextProps.defaultValue));
    }
  }, {
    key: "shouldComponentUpdate",
    value: function shouldComponentUpdate(nextProps, nextState) {
      return (0, _utils.shouldRender)(this, nextProps, nextState);
    }
  }, {
    key: "render",
    value: function render() {
      var id = this.props.id;
      var _state = this.state;
      var year = _state.year;
      var month = _state.month;
      var day = _state.day;
      var hour = _state.hour;
      var minute = _state.minute;
      var second = _state.second;

      return _react2.default.createElement(
        "ul",
        { className: "list-inline" },
        _react2.default.createElement(DateElement, { type: "year", rootId: id, range: [1900, 2020],
          value: year, select: this.onYearChange }),
        _react2.default.createElement(DateElement, { type: "month", rootId: id, range: [1, 12],
          value: month, select: this.onMonthChange }),
        _react2.default.createElement(DateElement, { type: "day", rootId: id, range: [1, 31],
          value: day, select: this.onDayChange }),
        _react2.default.createElement(DateElement, { type: "hour", rootId: id, range: [0, 23],
          value: hour, select: this.onHourChange }),
        _react2.default.createElement(DateElement, { type: "minute", rootId: id, range: [0, 59],
          value: minute, select: this.onMinuteChange }),
        _react2.default.createElement(DateElement, { type: "second", rootId: id, range: [0, 59],
          value: second, select: this.onSecondChange })
      );
    }
  }]);

  return DateTimeWidget;
}(_react.Component);

if (process.env.NODE_ENV !== "production") {
  DateTimeWidget.propTypes = {
    schema: _react.PropTypes.object.isRequired,
    id: _react.PropTypes.string.isRequired,
    placeholder: _react.PropTypes.string,
    value: _react2.default.PropTypes.string,
    defaultValue: _react2.default.PropTypes.string,
    required: _react.PropTypes.bool,
    onChange: _react.PropTypes.func
  };
}

exports.default = DateTimeWidget;